/*
 * This file is part of LibQtTracker project
 *
 * Copyright (C) 2010 Nokia
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */
#include "util_p.h"
#include <unistd.h>
#include <stdarg.h>
#include <sys/time.h>
#include <string.h>
#include <stdio.h>
#include <QCoreApplication>
// LCOV_EXCL_START

namespace SopranoLive
{
	void perfEvent(char const *fmt, ...)
	{
		static char tsbuf[32];
		static char msgbuf[512];
		static char const nl = '\n';

		struct timeval tv;
		gettimeofday(&tv, NULL);

		snprintf(tsbuf, sizeof(tsbuf), "%lu\t", tv.tv_sec * 1000 + tv.tv_usec / 1000);
		va_list args;
		va_start(args, fmt);
		vsnprintf(msgbuf, sizeof(msgbuf), fmt, args);
		va_end(args);
		write(PERF_LOG_FD, tsbuf, strlen(tsbuf));
		write(PERF_LOG_FD, msgbuf, strlen(msgbuf));
		write(PERF_LOG_FD, &nl, 1);
	}

	void processEventsAndDeferredDeletes()
	{
		while(QCoreApplication::hasPendingEvents())
		{
			QCoreApplication::sendPostedEvents();
			QCoreApplication::sendPostedEvents(0, QEvent::DeferredDelete);
			QCoreApplication::processEvents();
		}
	}

}
// LCOV_EXCL_STOP

