/*
 * This file is part of LibQtTracker project
 *
 * Copyright (C) 2010 Nokia
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */
#ifndef SOPRANOLIVE_UTIL_P_H_
#define SOPRANOLIVE_UTIL_P_H_

#ifdef PROFILE_TIMESTAMPS
# define PERF_EVENT(fmt, ...) perfEvent(fmt, ##__VA_ARGS__)
#else
# define PERF_EVENT(...)
#endif

#define PERF_LOG_FD 5

namespace SopranoLive
{
    void perfEvent(char const *fmt, ...);
}
#endif

namespace SopranoLive
{
	void processEventsAndDeferredDeletes();

		template<class T>
	struct TLSDestroyer
		: T
	{
			TLSDestroyer(T const &t)
			: T(t)
		{}

		~TLSDestroyer()
		{
			this->clear();
			processEventsAndDeferredDeletes();
		}
	};
}
